'Raffaello Bervini, 6818 Melano (Switzerland)
'ripreso il 23 aprile 2005 per PBWin 8.01
#DIM ALL
#COMPILE EXE
#INCLUDE "WIN32API.INC"
#INCLUDE "pb8libreria.bas"
GLOBAL hDlg AS LONG
GLOBAL fonta() AS STRING
DECLARE SUB LCD(hDlg AS LONG,id AS LONG,testo AS STRING,coltesto AS LONG,bordotesto AS LONG)
DECLARE SUB matrixfont_init
DECLARE FUNCTION  converti(BYVAL testo AS STRING) AS STRING
DECLARE CALLBACK FUNCTION CB()
%vx=5
%vy=7
'----------------------------------------------------------------------------------
FUNCTION PBMAIN
 DIM pb8botfx(10000) AS controllo
 LOCAL px,py,la,al AS LONG

 DIALOG NEW PIXELS,0,"LCD display matrix...version 0.2",,,500,200, _
    %WS_POPUP OR %WS_VISIBLE OR %WS_CLIPCHILDREN OR %WS_CAPTION OR _
    %WS_SYSMENU OR %WS_MINIMIZEBOX OR 0*%WS_MAXIMIZE OR %WS_MAXIMIZEBOX OR %WS_THICKFRAME OR _
    %WS_CLIPSIBLINGS OR %DS_CENTER TO hDlg

 px=10:py=10:la=230:al=37
 pb8lcd_def hDlg,207,px,py,la,al,"",4,"oro",0,0,"",%GREEN,"","",5:py=py+al+4
 pb8lcd_def hDlg,208,px,py,la,60,"",6,"oro",0,0,"",%GREEN,"","",5:py=py+al+4
 CALL matrixfont_init

 DIALOG SHOW MODAL hDlg, CALL CB()
END FUNCTION
'----------------------------------------------------------------------------------
CALLBACK FUNCTION CB()
 SELECT CASE CBMSG
  CASE %WM_COMMAND
   IF CBCTL=402 THEN BEEP:DIALOG END CBHNDL

  CASE %WM_INITDIALOG
   SetTimer CBHNDL,1,100,BYVAL 0
   FUNCTION=%TRUE

  CASE %WM_TIMER
   SELECT CASE CBWPARAM
    CASE 1
     LCD hDlg,207,converti(TRIM$(USING$("#####.##",TIMER))),RGB(40,50,40),0
     LCD hDlg,208,converti(TRIM$(TIME$)),%LTGRAY,1
   END SELECT
   FUNCTION=%TRUE

 END SELECT
END FUNCTION
'----------------------------------------------------------------------------------
SUB LCD(hDlg AS LONG,id AS LONG,testo AS STRING,coltesto AS LONG,bordotesto AS LONG)
 LOCAL xi,yi,delta,latox,latoy AS SINGLE,v,o,j,la,al AS LONG,c AS STRING

 GRAPHIC ATTACH hDlg,id,REDRAW
 GRAPHIC GET CLIENT TO la,al
 IF pb8bmp(id)>"" THEN GRAPHIC SET BITS pb8bmp(id)
 delta=2*pb8botfx(id).lar_cornice'+0.05*al
 latox=(la-1.5*delta)\((%vx+1)*LEN(testo)):latoy=(al-2*delta)\%vy
'GRAPHIC BOX (delta,delta)-(delta+latox*(%vx+1)*LEN(testo),delta+latoy*%vy),0,%red
 FOR j=1 TO LEN(testo)
  c=MID$(testo,j,1)
  FOR o=0 TO %vx-1
   FOR v=0 TO %vy-1
    xi=(o+(j-1)*6)*latox+delta:yi=v*latoy+delta
    IF MID$(fonta(ASC(c$),v),o+1,1)="X" THEN
     IF bordotesto=1 THEN GRAPHIC BOX (xi+2,yi+3)-(xi+latox+1,yi+latoy+2),0,RGB(92,152,92),RGB(92,152,92)
     GRAPHIC BOX (xi,yi)-(xi+latox-1,yi+latoy-1),0,coltesto,coltesto
    ELSE
     IF bordotesto<0 THEN GRAPHIC BOX (xi+2,yi+3)-(xi+latox+1,yi+latoy+2),0,RGB(92,152,92),RGB(92,152,92)
    END IF
   NEXT v
  NEXT o
 NEXT
 GRAPHIC REDRAW
END SUB
'----------------------------------------------------------------------------------
FUNCTION converti(BYVAL testo AS STRING) AS STRING
 LOCAL i AS LONG,dummy AS LONG
 FOR i=1 TO LEN(testo)
  dummy=ASC(MID$(testo,i,1))
  SELECT CASE dummy
   CASE 46 TO 57
    MID$(testo,i,1)=CHR$(dummy+176)
  END SELECT
 NEXT
 FUNCTION=testo
END FUNCTION
'----------------------------------------------------------------------------------
SUB matrixfont_init
 LOCAL i AS LONG,j AS LONG
 DIM fonta(0:256,0:6)
 FOR i=0 TO 15
  FOR j=0 TO 6: fonta(256,j)=fonta(256,j)+READ$(i*7+j+1): NEXT
 NEXT
 FOR i=0 TO 255
  FOR j=0 TO 6: fonta(i,j)=MID$(fonta(256,j),i*6+1,5): NEXT
 NEXT
'Matrix font
'----------------------------------------------------------------------------------
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "

 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "

 DATA "..... ..X.. .X.X. .X.X. ..X.. XX..X .X... .XX.. ..X.. .X... X.X.X ..X.. ..... ..... ..... ....X "
 DATA "..... ..X.. .X.X. .X.X. .XXXX XX..X X.X.. ..X.. .X... ..X.. .XXX. ..X.. ..... ..... ..... ....X "
 DATA "..... ..X.. .X.X. XXXXX X.X.. ...X. X.X.. .X... .X... ..X.. ..X.. ..X.. ..... ..... ..... ...X. "
 DATA "..... ..X.. ..... .X.X. .XXX. ..X.. .X... ..... .X... ..X.. .XXX. XXXXX ..... XXX.. ..... ..X.. "
 DATA "..... ..X.. ..... XXXXX ..X.X .X... X.X.X ..... .X... ..X.. X.X.X ..X.. .XX.. ..... ..... .X... "
 DATA "..... ..... ..... .X.X. XXXX. X..XX X..X. ..... .X... ..X.. ..... ..X.. ..X.. ..... .XX.. X.... "
 DATA "..... ..X.. ..... .X.X. ..X.. X..XX .XX.X ..... ..X.. .X... ..... ..X.. .X... ..... .XX.. X.... "

 DATA ".XXX. ..X.. .XXX. XXXXX ...X. XXXXX ..XX. XXXXX .XXX. .XXX. ..... ..... ...X. ..... X.... .XXX. "
 DATA "X...X .XX.. X...X ...X. ..XX. X.... .X... ....X X...X X...X ..... .XX.. ..X.. ..... .X... X...X "
 DATA "X..XX ..X.. ....X ..X.. .X.X. XXXX. X.... ...X. X...X X...X ..X.. .XX.. .X... XXXXX ..X.. ....X "
 DATA "X.X.X ..X.. ...X. ...X. X..X. ....X XXXX. ..X.. .XXX. .XXXX ..... ..... X.... ..... ...X. ...X. "
 DATA "XX..X ..X.. ..X.. ....X XXXXX ....X X...X .X... X...X ....X ..X.. .XX.. .X... XXXXX ..X.. ..X.. "
 DATA "X...X ..X.. .X... X...X ...X. X...X X...X .X... X...X ...X. ..... ..X.. ..X.. ..... .X... ..... "
 DATA ".XXX. .XXX. XXXXX .XXX. ...X. .XXX. .XXX. .X... .XXX. .XX.. ..... .X... ...X. ..... X.... ..X.. "

 DATA ".XXX. .XXX. XXXX. .XXX. XXXX. XXXXX XXXXX .XXX. X...X XXX.. ..XXX X...X X.... X...X X...X .XXX. "
 DATA "X...X X...X X...X X...X X...X X.... X.... X...X X...X .X... ...X. X..X. X.... XX.XX X...X X...X "
 DATA "X..XX X...X X...X X.... X...X X.... X.... X.... X...X .X... ...X. X.X.. X.... X.X.X XX..X X...X "
 DATA "X.X.. XXXXX XXXX. X.... X...X XXXX. XXXX. X.XXX XXXXX .X... ...X. XX... X.... X.X.X X.X.X X...X "
 DATA "X.X.X X...X X...X X.... X...X X.... X.... X...X X...X .X... ...X. X.X.. X.... X...X X..XX X...X "
 DATA "X...X X...X X...X X...X X...X X.... X.... X...X X...X .X... X..X. X..X. X.... X...X X...X X...X "
 DATA ".XXX. X...X XXXX. .XXX. XXXX. XXXXX X.... .XXXX X...X XXX.. .XX.. X...X XXXXX X...X X...X .XXX. "

 DATA "XXXX. .XXX. XXXX. .XXXX XXXXX X...X X...X X...X X...X X...X XXXXX .XXX. X.... .XXX. ..X.. ..... "
 DATA "X...X X...X X...X X.... ..X.. X...X X...X X...X X...X X...X ....X .X... X.... ...X. .X.X. ..... "
 DATA "X...X X...X X...X X.... ..X.. X...X X...X X...X .X.X. X...X ...X. .X... .X... ...X. X...X ..... "
 DATA "XXXX. X...X XXXX. .XXX. ..X.. X...X X...X X.X.X ..X.. .X.X. ..X.. .X... ..X.. ...X. ..... ..... "
 DATA "X.... X.X.X X.X.. ....X ..X.. X...X X...X X.X.X .X.X. ..X.. .X... .X... ...X. ...X. ..... ..... "
 DATA "X.... X..X. X..X. ....X ..X.. X...X .X.X. X.X.X X...X ..X.. X.... .X... ....X ...X. ..... ..... "
 DATA "X.... .XX.X X...X XXXX. ..X.. .XXX. ..X.. .X.X. X...X ..X.. XXXXX .XXX. ....X .XXX. ..... XXXXX "

 DATA ".XX.. ..... X.... ..... ....X ..... ..XX. ..... X.... ..X.. ...X. X.... .XX.. ..... ..... ..... "
 DATA ".X... ..... X.... ..... ....X ..... .X..X .XXXX X.... ..... ..... X.... ..X.. ..... ..... ..... "
 DATA "..X.. .XXX. X.XX. .XXX. .XX.X .XXX. .X... X...X X.XX. .XX.. ..XX. X..X. ..X.. XX.X. X.XX. .XXX. "
 DATA "..... ....X XX..X X.... X..XX X...X XXX.. X...X XX..X ..X.. ...X. X.X.. ..X.. X.X.X XX..X X...X "
 DATA "..... .XXXX X...X X.... X...X XXXXX .X... .XXXX X...X ..X.. ...X. XX... ..X.. X.X.X X...X X...X "
 DATA "..... X...X X...X X...X X...X X.... .X... ....X X...X ..X.. X..X. X.X.. ..X.. X...X X...X X...X "
 DATA "..... .XXXX XXXX. .XXX. .XXXX .XXX. .X... .XXX. X...X .XXX. .XX.. X..X. .XXX. X...X X...X .XXX. "

 DATA "..... ..... ..... ..... .X... ..... ..... ..... ..... ..... ..... ...X. ..X.. .X... ..... ..... "
 DATA "..... ..... ..... ..... .X... ..... ..... ..... ..... ..... ..... ..X.. ..X.. ..X.. ..... ..... "
 DATA "XXXX. .XXXX X.XX. .XXX. XXX.. X...X X...X X...X X...X X...X XXXXX ..X.. ..X.. ..X.. .X... ..... "
 DATA "X...X X...X XX..X X.... .X... X...X X...X X...X .X.X. X...X ...X. .X... ..... ...X. X.X.X ..... "
 DATA "XXXX. .XXXX X.... .XXX. .X... X...X X...X X.X.X ..X.. .XXXX ..X.. ..X.. ..X.. ..X.. ...X. ..... "
 DATA "X.... ....X X.... ....X .X..X X..XX .X.X. X.X.X .X.X. ....X .X... ..X.. ..X.. ..X.. ..... XX... "
 DATA "X.... ....X X.... XXXX. ..XX. .XX.X ..X.. .X.X. X...X .XXX. XXXXX ...X. ..X.. .X... ..... XX... "

 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "

 DATA "..... ..X.. .XX.. .X..X XX.XX ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... .X... ..X.. X..X. .X..X ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... .XX.. .X... XX.XX X..X. ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "XX... ..... ..... ..... ..... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "
 DATA "XX... ..... ..... ..... ..... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "

 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "

 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "

 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... "

 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ....X "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ....X "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ...X. "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..X.. "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... .X... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... ..... X.... "
 DATA "XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... XX... ..X.. X.... "

 DATA "XXXXX ..X.. XXXXX XXXXX X...X XXXXX XXXXX XXXXX XXXXX XXXXX ..... ..... ..... ..... ..... ..... "
 DATA "X...X ..X.. ....X ....X X...X X.... X.... ....X X...X X...X ..... ..... ..... ..... ..... ..... "
 DATA "X...X ..X.. ....X ....X X...X X.... X.... ....X X...X X...X ..... ..... ..... ..... ..... ..... "
 DATA "X...X ..X.. XXXXX XXXXX XXXXX XXXXX XXXXX ....X XXXXX XXXXX ..... ..... ..... ..... ..... ..... "
 DATA "X...X ..X.. X.... ....X ....X ....X X...X ....X X...X ....X ..... ..... ..... ..... ..... ..... "
 DATA "X...X ..X.. X.... ....X ....X ....X X...X ....X X...X ....X XX... XX... XX... XX... XX... XX... "
 DATA "XXXXX ..X.. XXXXX XXXXX ....X XXXXX XXXXX ....X XXXXX XXXXX XX... XX... XX... XX... XX... XX... "

 DATA "..... ..... ..... ..... ..... ..... ..... ..... .XXX. ..... ..... ..... ..... XXXXX ..... XXXXX "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... .X.X. ..... ..... ..... ..... ..... XXXXX XXXXX "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... .XXX. ..... ..... ..... ..... XXXXX ..... XXXXX "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... XXXXX XXXXX "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... XXXXX ..... XXXXX "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... XXXXX XXXXX "
 DATA "..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... ..... XXXXX ..... XXXXX "
END SUB
'----------------------------------------------------------------------------------
